TRANSLATOR_PATH="/home/thomas/Programmes/ASTD2B/"   # The path where the ASTD2B translator is
ASTD_FILE_PATH=$TRANSLATOR_PATH"Train_Control_Specification/" # The path to the ASTD specification files
PROJECT="Case_Study"  # The name of the project
PROJECT_PATH="/home/thomas/BProjects/" # The path where you want to create the project
BDP_DIR=$PROJECT_PATH$PROJECT'/bdp'   #The bdp path of the project
LANG_DIR=$PROJECT_PATH$PROJECT'/lang'  #The lang path of B project
ACTION_FILES=$ASTD_FILE_PATH'ACTION_MACHINES/' # The path where the actions machines are
ATELIERB_PATH='/opt/atelierb-4.1/' # The atelierB installation Path
BDP_PROJECT_FILE=$ATELIERB_PATH'press/bdb/'$PROJECT'.desc' #Don't change this line
PMM_PATH=$ASTD_FILE_PATH'PMM/'  #The path of the PMM project

########################################################################
#
#
#               REMOVING EXISTING FILES
#               CREATING NEW PROJECT
#
#
########################################################################

PROJECT_DIR=$PROJECT_PATH$PROJECT
if [[ -d $PROJECT_PATH$PROJECT ]]
then
    rm -r  $PROJECT_DIR
    rm $BDP_PROJECT_FILE
    echo "Deleting Files"
fi

echo "Recreating Project"
mkdir $PROJECT_DIR
mkdir $BDP_DIR
mkdir $LANG_DIR
echo 'create_project '$PROJECT $BDP_DIR $LANG_DIR' SOFTWARE' > add_files.txt
echo 'open_project '$PROJECT >> add_files.txt

cp $ACTION_FILES'TRACK_DEF.mch' $PROJECT_DIR
echo 'add_file '$PROJECT_DIR'/TRACK_DEF.mch' >> add_files.txt

echo "Adding Files"
for i in `seq 1 6`
do
    echo "Translating specification number " $i
    if [[ $i == 2 || $i == 6 ]]
    then
	act=$(($i-1))
    else
	act=$i
    fi
    MACHINE_NAME=TRAIN_CONTROL_M$i
    ASTD_FILE_NAME="ASTD_SPEC/trainControl_m"$i
    ASTD_READ_PATH=$ASTD_FILE_PATH
    INCLUDED_FILE="TRAIN_CONTROL_M"$act"_ACT"
    RESULT_FILE=$MACHINE_NAME".mch"
    INV_FILE="INV/INV_M"$i".txt"
    ASSERT_FILE="ASSERT/ASSERT_M"$i".txt"
    echo "t"
    $TRANSLATOR_PATH/iASTD -read $ASTD_READ_PATH -s $ASTD_FILE_NAME -name $MACHINE_NAME -includes $INCLUDED_FILE -invFile $INV_FILE -assertFile $ASSERT_FILE -sees "TRACK_DEF" > $PROJECT_DIR'/'$RESULT_FILE
    echo 'add_file '$PROJECT_DIR'/'$RESULT_FILE >> add_files.txt
    cp $PMM_PATH/$MACHINE_NAME'.pmm' $PROJECT_DIR
    if [[ $i != 2 && $i != 6 ]]
    then
	echo 'add_file '$PROJECT_DIR'/'$INCLUDED_FILE'.mch' >> add_files.txt
	cp $ACTION_FILES$INCLUDED_FILE'.mch' $PROJECT_DIR
    fi
    echo "toto"
done
startBB < add_files.txt

###################################################################################
#
#                       PROVING THE PROJECT
#
###################################################################################

./preuve.sh $PROJECT 'TRACK_DEF'
echo "Proving files"
for i in `seq 1 6`
do
    echo "Proving TRAIN_CONTROL_M"$i
    MACHINE_NAME=TRAIN_CONTROL_M$i
    ./preuve.sh $PROJECT $MACHINE_NAME
    if [[ $i != 2 && $i != 6 ]]
    then
	echo "Proving TRAIN_CONTROL_M"$i"_ACT"
	MACHINE_NAME=TRAIN_CONTROL_M$i'_ACT'
	./preuve.sh $PROJECT $MACHINE_NAME
    fi
done
